/* A Bison parser, made by GNU Bison 3.6.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2020 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.6.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 1 "query_parser.y"

/*
 * query_parser.y - yacc/bison grammar for the PCP time series language
 *
 * Copyright (c) 2017-2019 Red Hat.
 * Copyright (c) 2020 Yushan ZHANG.
 * 
 * This library is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2.1 of the License, or
 * (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
 * License for more details.
 */

#include <ctype.h>
#include "query.h"
#include "load.h"
#include "util.h"
#include "libpcp.h"

typedef struct PARSER {
    char	*yy_input;
    char	*yy_lexicon;
    int		yy_lexpeek;
    int		yy_error;
    sds		yy_errstr;
    char	*yy_tokbuf;
    int 	yy_tokbuflen;
    meta_t	yy_meta;
    sds		yy_base;
    node_t	*yy_np;
    series_t	yy_series;
} PARSER;

typedef union {
    sds		s;
    node_t	*n;
    meta_t	m;
} YYSTYPE;

#define YYSTYPE_IS_DECLARED 1
static int yylex(YYSTYPE *, PARSER *);
static int yyerror(PARSER *, const char *);

static int series_lex(YYSTYPE *, PARSER *);
static int series_error(PARSER *, const char *);
static void gramerr(PARSER *, const char *, const char *, char *);
static node_t *newnode(int);
static node_t *newmetric(char *);
static node_t *newmetricquery(char *, node_t *);
static node_t *newtree(int, node_t *, node_t *);
static void newaligntime(PARSER *, const char *);
static void newstarttime(PARSER *, const char *);
static void newinterval(PARSER *, const char *);
static void newendtime(PARSER *, const char *);
static void newrange(PARSER *, const char *);
static void newtimezone(PARSER *, const char *);
static void newsamples(PARSER *, const char *);
static void newoffset(PARSER *, const char *);
static char *n_type_str(int);
static char *n_type_c(int);
static char *l_type_str(int);

/* strings for error reporting */
static const char follow[]       = "follow";
//static const char bexpr_str[]    = "Boolean expression";
//static const char aexpr_str[]    = "Arithmetic expression";
static const char op_str[]       = "Arithmetic or relational or boolean operator";
static const char name_str[]     = "Symbol";
static const char unexpected_str[]       = "Unexpected";
static const char initial_str[]  = "Unexpected initial";

#line 148 "query_parser.tab.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

/* Use api.header.include to #include this header
   instead of duplicating it here.  */
#ifndef YY_YY_QUERY_PARSER_TAB_H_INCLUDED
# define YY_YY_QUERY_PARSER_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token kinds.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    YYEMPTY = -2,
    YYEOF = 0,                     /* "end of file"  */
    YYerror = 256,                 /* error  */
    YYUNDEF = 257,                 /* "invalid token"  */
    L_UNDEF = 258,                 /* L_UNDEF  */
    L_ERROR = 259,                 /* L_ERROR  */
    L_EOS = 260,                   /* L_EOS  */
    L_PLUS = 261,                  /* L_PLUS  */
    L_MINUS = 262,                 /* L_MINUS  */
    L_STAR = 263,                  /* L_STAR  */
    L_SLASH = 264,                 /* L_SLASH  */
    L_COLON = 265,                 /* L_COLON  */
    L_LPAREN = 266,                /* L_LPAREN  */
    L_RPAREN = 267,                /* L_RPAREN  */
    L_LBRACE = 268,                /* L_LBRACE  */
    L_RBRACE = 269,                /* L_RBRACE  */
    L_LSQUARE = 270,               /* L_LSQUARE  */
    L_RSQUARE = 271,               /* L_RSQUARE  */
    L_ABS = 272,                   /* L_ABS  */
    L_FLOOR = 273,                 /* L_FLOOR  */
    L_LOG = 274,                   /* L_LOG  */
    L_SQRT = 275,                  /* L_SQRT  */
    L_ROUND = 276,                 /* L_ROUND  */
    L_AVG = 277,                   /* L_AVG  */
    L_COUNT = 278,                 /* L_COUNT  */
    L_DELTA = 279,                 /* L_DELTA  */
    L_MAX = 280,                   /* L_MAX  */
    L_MIN = 281,                   /* L_MIN  */
    L_SUM = 282,                   /* L_SUM  */
    L_ANON = 283,                  /* L_ANON  */
    L_RATE = 284,                  /* L_RATE  */
    L_INSTANT = 285,               /* L_INSTANT  */
    L_LT = 286,                    /* L_LT  */
    L_LEQ = 287,                   /* L_LEQ  */
    L_EQ = 288,                    /* L_EQ  */
    L_GLOB = 289,                  /* L_GLOB  */
    L_GEQ = 290,                   /* L_GEQ  */
    L_GT = 291,                    /* L_GT  */
    L_NEQ = 292,                   /* L_NEQ  */
    L_REQ = 293,                   /* L_REQ  */
    L_RNE = 294,                   /* L_RNE  */
    L_AND = 295,                   /* L_AND  */
    L_OR = 296,                    /* L_OR  */
    L_MKCONST = 297,               /* L_MKCONST  */
    L_RESCALE = 298,               /* L_RESCALE  */
    L_DEFINED = 299,               /* L_DEFINED  */
    L_TYPE = 300,                  /* L_TYPE  */
    L_SEMANTICS = 301,             /* L_SEMANTICS  */
    L_UNITS = 302,                 /* L_UNITS  */
    L_ASSIGN = 303,                /* L_ASSIGN  */
    L_COMMA = 304,                 /* L_COMMA  */
    L_INTERVAL = 305,              /* L_INTERVAL  */
    L_TIMEZONE = 306,              /* L_TIMEZONE  */
    L_ALIGN = 307,                 /* L_ALIGN  */
    L_START = 308,                 /* L_START  */
    L_FINISH = 309,                /* L_FINISH  */
    L_SAMPLES = 310,               /* L_SAMPLES  */
    L_OFFSET = 311,                /* L_OFFSET  */
    EVENT_UNIT = 312,              /* EVENT_UNIT  */
    TIME_UNIT = 313,               /* TIME_UNIT  */
    SPACE_UNIT = 314,              /* SPACE_UNIT  */
    L_INTEGER = 315,               /* L_INTEGER  */
    L_DOUBLE = 316,                /* L_DOUBLE  */
    L_NAME = 317,                  /* L_NAME  */
    L_STRING = 318,                /* L_STRING  */
    L_RANGE = 319                  /* L_RANGE  */
  };
  typedef enum yytokentype yytoken_kind_t;
#endif

/* Value type.  */



int yyparse (PARSER *lp);

#endif /* !YY_YY_QUERY_PARSER_TAB_H_INCLUDED  */
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_L_UNDEF = 3,                    /* L_UNDEF  */
  YYSYMBOL_L_ERROR = 4,                    /* L_ERROR  */
  YYSYMBOL_L_EOS = 5,                      /* L_EOS  */
  YYSYMBOL_L_PLUS = 6,                     /* L_PLUS  */
  YYSYMBOL_L_MINUS = 7,                    /* L_MINUS  */
  YYSYMBOL_L_STAR = 8,                     /* L_STAR  */
  YYSYMBOL_L_SLASH = 9,                    /* L_SLASH  */
  YYSYMBOL_L_COLON = 10,                   /* L_COLON  */
  YYSYMBOL_L_LPAREN = 11,                  /* L_LPAREN  */
  YYSYMBOL_L_RPAREN = 12,                  /* L_RPAREN  */
  YYSYMBOL_L_LBRACE = 13,                  /* L_LBRACE  */
  YYSYMBOL_L_RBRACE = 14,                  /* L_RBRACE  */
  YYSYMBOL_L_LSQUARE = 15,                 /* L_LSQUARE  */
  YYSYMBOL_L_RSQUARE = 16,                 /* L_RSQUARE  */
  YYSYMBOL_L_ABS = 17,                     /* L_ABS  */
  YYSYMBOL_L_FLOOR = 18,                   /* L_FLOOR  */
  YYSYMBOL_L_LOG = 19,                     /* L_LOG  */
  YYSYMBOL_L_SQRT = 20,                    /* L_SQRT  */
  YYSYMBOL_L_ROUND = 21,                   /* L_ROUND  */
  YYSYMBOL_L_AVG = 22,                     /* L_AVG  */
  YYSYMBOL_L_COUNT = 23,                   /* L_COUNT  */
  YYSYMBOL_L_DELTA = 24,                   /* L_DELTA  */
  YYSYMBOL_L_MAX = 25,                     /* L_MAX  */
  YYSYMBOL_L_MIN = 26,                     /* L_MIN  */
  YYSYMBOL_L_SUM = 27,                     /* L_SUM  */
  YYSYMBOL_L_ANON = 28,                    /* L_ANON  */
  YYSYMBOL_L_RATE = 29,                    /* L_RATE  */
  YYSYMBOL_L_INSTANT = 30,                 /* L_INSTANT  */
  YYSYMBOL_L_LT = 31,                      /* L_LT  */
  YYSYMBOL_L_LEQ = 32,                     /* L_LEQ  */
  YYSYMBOL_L_EQ = 33,                      /* L_EQ  */
  YYSYMBOL_L_GLOB = 34,                    /* L_GLOB  */
  YYSYMBOL_L_GEQ = 35,                     /* L_GEQ  */
  YYSYMBOL_L_GT = 36,                      /* L_GT  */
  YYSYMBOL_L_NEQ = 37,                     /* L_NEQ  */
  YYSYMBOL_L_REQ = 38,                     /* L_REQ  */
  YYSYMBOL_L_RNE = 39,                     /* L_RNE  */
  YYSYMBOL_L_AND = 40,                     /* L_AND  */
  YYSYMBOL_L_OR = 41,                      /* L_OR  */
  YYSYMBOL_L_MKCONST = 42,                 /* L_MKCONST  */
  YYSYMBOL_L_RESCALE = 43,                 /* L_RESCALE  */
  YYSYMBOL_L_DEFINED = 44,                 /* L_DEFINED  */
  YYSYMBOL_L_TYPE = 45,                    /* L_TYPE  */
  YYSYMBOL_L_SEMANTICS = 46,               /* L_SEMANTICS  */
  YYSYMBOL_L_UNITS = 47,                   /* L_UNITS  */
  YYSYMBOL_L_ASSIGN = 48,                  /* L_ASSIGN  */
  YYSYMBOL_L_COMMA = 49,                   /* L_COMMA  */
  YYSYMBOL_L_INTERVAL = 50,                /* L_INTERVAL  */
  YYSYMBOL_L_TIMEZONE = 51,                /* L_TIMEZONE  */
  YYSYMBOL_L_ALIGN = 52,                   /* L_ALIGN  */
  YYSYMBOL_L_START = 53,                   /* L_START  */
  YYSYMBOL_L_FINISH = 54,                  /* L_FINISH  */
  YYSYMBOL_L_SAMPLES = 55,                 /* L_SAMPLES  */
  YYSYMBOL_L_OFFSET = 56,                  /* L_OFFSET  */
  YYSYMBOL_EVENT_UNIT = 57,                /* EVENT_UNIT  */
  YYSYMBOL_TIME_UNIT = 58,                 /* TIME_UNIT  */
  YYSYMBOL_SPACE_UNIT = 59,                /* SPACE_UNIT  */
  YYSYMBOL_L_INTEGER = 60,                 /* L_INTEGER  */
  YYSYMBOL_L_DOUBLE = 61,                  /* L_DOUBLE  */
  YYSYMBOL_L_NAME = 62,                    /* L_NAME  */
  YYSYMBOL_L_STRING = 63,                  /* L_STRING  */
  YYSYMBOL_L_RANGE = 64,                   /* L_RANGE  */
  YYSYMBOL_YYACCEPT = 65,                  /* $accept  */
  YYSYMBOL_query = 66,                     /* query  */
  YYSYMBOL_vector = 67,                    /* vector  */
  YYSYMBOL_exprlist = 68,                  /* exprlist  */
  YYSYMBOL_exprval = 69,                   /* exprval  */
  YYSYMBOL_string = 70,                    /* string  */
  YYSYMBOL_number = 71,                    /* number  */
  YYSYMBOL_timelist = 72,                  /* timelist  */
  YYSYMBOL_timespec = 73,                  /* timespec  */
  YYSYMBOL_timeexpr = 74,                  /* timeexpr  */
  YYSYMBOL_expr = 75,                      /* expr  */
  YYSYMBOL_val_vec = 76,                   /* val_vec  */
  YYSYMBOL_sid_vec = 77,                   /* sid_vec  */
  YYSYMBOL_func_sid = 78,                  /* func_sid  */
  YYSYMBOL_arithmetic_expr_sid = 79,       /* arithmetic_expr_sid  */
  YYSYMBOL_func = 80,                      /* func  */
  YYSYMBOL_arithmetic_expression = 81      /* arithmetic_expression  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  38
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   534

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  65
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  17
/* YYNRULES -- Number of rules.  */
#define YYNRULES  122
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  311

#define YYMAXUTOK   319


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   188,   188,   189,   197,   202,   208,   210,   212,   218,
     223,   228,   235,   241,   244,   245,   248,   253,   260,   265,
     272,   273,   277,   278,   279,   283,   285,   287,   289,   291,
     293,   295,   297,   302,   304,   306,   308,   310,   312,   316,
     318,   320,   322,   326,   328,   335,   340,   348,   352,   359,
     364,   369,   374,   379,   384,   389,   407,   425,   430,   435,
     440,   445,   451,   457,   462,   467,   472,   477,   482,   487,
     494,   500,   506,   512,   518,   524,   530,   536,   542,   548,
     554,   560,   566,   572,   578,   584,   593,   598,   603,   608,
     613,   618,   623,   641,   659,   664,   669,   674,   679,   685,
     691,   696,   701,   706,   711,   716,   721,   727,   733,   739,
     745,   751,   757,   763,   769,   775,   781,   787,   793,   799,
     805,   811,   817
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "L_UNDEF", "L_ERROR",
  "L_EOS", "L_PLUS", "L_MINUS", "L_STAR", "L_SLASH", "L_COLON", "L_LPAREN",
  "L_RPAREN", "L_LBRACE", "L_RBRACE", "L_LSQUARE", "L_RSQUARE", "L_ABS",
  "L_FLOOR", "L_LOG", "L_SQRT", "L_ROUND", "L_AVG", "L_COUNT", "L_DELTA",
  "L_MAX", "L_MIN", "L_SUM", "L_ANON", "L_RATE", "L_INSTANT", "L_LT",
  "L_LEQ", "L_EQ", "L_GLOB", "L_GEQ", "L_GT", "L_NEQ", "L_REQ", "L_RNE",
  "L_AND", "L_OR", "L_MKCONST", "L_RESCALE", "L_DEFINED", "L_TYPE",
  "L_SEMANTICS", "L_UNITS", "L_ASSIGN", "L_COMMA", "L_INTERVAL",
  "L_TIMEZONE", "L_ALIGN", "L_START", "L_FINISH", "L_SAMPLES", "L_OFFSET",
  "EVENT_UNIT", "TIME_UNIT", "SPACE_UNIT", "L_INTEGER", "L_DOUBLE",
  "L_NAME", "L_STRING", "L_RANGE", "$accept", "query", "vector",
  "exprlist", "exprval", "string", "number", "timelist", "timespec",
  "timeexpr", "expr", "val_vec", "sid_vec", "func_sid",
  "arithmetic_expr_sid", "func", "arithmetic_expression", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_int16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319
};
#endif

#define YYPACT_NINF (-186)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-1)

#define yytable_value_is_error(Yyn) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
      82,    50,    11,    25,    57,    72,   113,   121,   135,   160,
     173,   132,    96,  -186,   517,   521,   508,  -186,   513,  -186,
    -186,  -186,    36,   165,   127,   110,   110,   110,   110,   110,
     110,   110,   110,   110,  -186,    50,   237,    97,  -186,   131,
     131,   131,   131,   144,   144,   144,   144,  -186,   144,   144,
     144,   144,  -186,   131,   131,   131,   131,   290,    50,   471,
     167,   167,   471,   471,   167,   167,   471,    50,    50,    50,
      50,   177,   311,   318,   325,   332,   339,   346,   353,   360,
      85,   170,   201,   209,   367,   374,   381,   388,   395,   402,
     409,   416,   423,   430,   437,   444,   451,   458,   465,   472,
     479,   486,   493,   500,    31,   245,   263,   267,    37,    94,
     133,   195,   213,   215,   238,   246,  -186,    89,  -186,   242,
    -186,   266,   288,   324,   331,   338,   345,   352,   359,   366,
     199,   289,   306,   289,   306,  -186,  -186,  -186,  -186,   373,
     380,   387,   394,   401,   408,   415,   422,   429,   323,   313,
     320,   313,   320,  -186,  -186,  -186,  -186,   313,   320,   313,
     320,  -186,  -186,  -186,  -186,   289,   306,   289,   306,  -186,
    -186,  -186,  -186,  -186,   237,   127,  -186,  -186,  -186,  -186,
    -186,  -186,  -186,  -186,  -186,  -186,  -186,  -186,  -186,  -186,
    -186,  -186,    50,   237,  -186,  -186,  -186,  -186,  -186,  -186,
    -186,  -186,  -186,   167,  -186,   167,  -186,   167,  -186,   167,
    -186,  -186,  -186,  -186,  -186,  -186,  -186,  -186,  -186,  -186,
    -186,  -186,  -186,  -186,  -186,  -186,  -186,  -186,  -186,  -186,
     239,   280,   287,   294,   291,   250,   301,   250,   250,   250,
     436,   443,   442,   237,   131,   131,   131,   131,   131,   131,
     131,   131,   131,    50,   144,   144,   144,   144,   144,   144,
     144,   144,   144,    50,    93,    70,   105,   449,   450,   456,
     457,   463,   464,   470,   477,  -186,   237,  -186,  -186,  -186,
    -186,  -186,  -186,  -186,  -186,  -186,  -186,  -186,  -186,    92,
     106,   478,   356,  -186,  -186,  -186,  -186,  -186,  -186,  -186,
    -186,  -186,   117,   356,  -186,  -186,   237,   485,   142,  -186,
    -186
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_int8 yydefact[] =
{
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    48,     0,     2,     0,     0,     0,    69,     0,   106,
      17,    16,     0,     0,    13,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     9,     0,     0,     0,     1,     0,
       0,     0,     0,     0,     0,     0,     0,    11,     0,     0,
       0,     0,    10,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    48,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    32,     0,    21,    48,
       3,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   107,   108,   111,   112,   115,   116,   119,   120,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    48,    70,
      71,    74,    75,    78,    79,    82,    83,    72,    73,    76,
      77,    80,    81,    84,    85,   109,   110,   113,   114,   117,
     118,   121,   122,     7,     0,    12,    18,    19,    41,    14,
      15,    33,    34,    35,    42,    36,    37,    38,    39,    40,
      43,    44,     0,     0,    94,    57,    58,    95,    96,    59,
      60,    97,   100,     0,    63,     0,    64,     0,   101,     0,
     102,    65,    66,   103,   104,    67,    68,   105,    88,    51,
      52,    89,    90,    53,    54,    91,    86,    49,    50,    87,
       0,     0,     0,     0,    47,     0,     0,     0,     0,     0,
       0,     0,    46,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     4,     0,    23,    24,    22,
      25,    26,    29,    30,    31,    27,    28,     8,    20,     0,
       0,     0,    47,    46,    98,    61,    62,    99,    92,    55,
      56,    93,     0,     0,    47,     6,     0,    45,     0,     5,
      45
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -186,  -186,   341,    -4,   123,   241,    17,   -95,  -185,   149,
     125,    16,   -25,   -16,  -186,    34,  -186
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    12,    13,    22,   178,    23,   180,   117,   280,   118,
      24,    14,    15,    16,    17,    18,    19
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      73,    77,    81,    85,    89,    93,    97,   101,   105,    74,
      78,    82,    86,    90,    94,    98,   102,   106,   149,   151,
     153,   155,    25,   157,   159,   161,   163,   150,   152,   154,
     156,   108,   158,   160,   162,   164,    26,    39,    40,    41,
      42,    72,    76,    80,    84,    88,    92,    96,   100,   104,
      57,   234,   282,   283,   284,   131,   133,   135,   137,    75,
      79,    83,    87,    91,    95,    99,   103,   107,    27,   165,
     167,   169,   171,   132,   134,   136,   138,   181,   182,   264,
     230,   185,   186,    28,   292,    58,    58,   166,   168,   170,
     172,    39,    40,    41,    42,     1,    38,   202,   266,     2,
       3,     4,     5,     6,   235,   242,   303,     7,     8,   291,
       1,     9,    20,    21,     2,     3,     4,     5,     6,    58,
     304,   293,     7,     8,    29,    10,     9,     2,     3,     4,
       5,     6,    30,   307,   203,     7,     8,    34,   243,     9,
      10,    58,   243,   236,    11,    35,    31,    36,   121,   122,
     123,   124,   125,    10,   243,    58,   126,   127,   310,   119,
     128,   139,   140,   141,   142,   143,   243,    69,    70,   144,
     145,    32,    71,   146,   129,    59,    43,    44,    45,    46,
      37,   302,   204,   175,    33,   183,   184,   147,   265,   187,
     192,   243,   193,   130,   190,   191,    60,    61,    62,    63,
      64,    65,    66,    67,    68,   237,   148,    48,    49,    50,
      51,   308,   253,   206,   193,    53,    54,    55,    56,   205,
     267,   208,   268,   238,   269,   239,   270,   176,   177,    73,
      77,    81,    85,    89,    93,    97,   101,   105,    74,    78,
      82,    86,    90,    94,    98,   102,   106,    34,   240,   289,
     207,    43,    44,    45,    46,    35,   241,    36,   209,   290,
      72,    76,    80,    84,    88,    92,    96,   100,   104,    48,
      49,    50,    51,    53,    54,    55,    56,   244,    75,    79,
      83,    87,    91,    95,    99,   103,   107,   109,   110,   111,
     112,   113,   114,   115,   231,   173,   275,    41,    42,   245,
     179,   116,   271,   179,   179,   174,   276,   179,   188,   189,
     277,   278,   232,   279,    55,    56,   233,    39,    40,    41,
      42,    45,    46,   194,    43,    44,    45,    46,    50,    51,
     195,    48,    49,    50,    51,   246,   263,   196,    53,    54,
      55,    56,   247,   272,   197,    39,    40,    41,    42,   248,
     273,   198,    43,    44,    45,    46,   249,   274,   199,    48,
      49,    50,    51,   250,   281,   200,    53,    54,    55,    56,
     251,   306,   201,    39,    40,    41,    42,   252,   120,   210,
      43,    44,    45,    46,   254,     0,   211,    48,    49,    50,
      51,   255,   288,   212,    53,    54,    55,    56,   256,     0,
     213,    39,    40,    41,    42,   257,     0,   214,    43,    44,
      45,    46,   258,     0,   215,    48,    49,    50,    51,   259,
       0,   216,    53,    54,    55,    56,   260,     0,   217,    39,
      40,    41,    42,   261,     0,   218,    43,    44,    45,    46,
     262,     0,   219,    48,    49,    50,    51,   287,     0,   220,
      53,    54,    55,    56,     0,     0,   221,    39,    40,    41,
      42,   294,   295,   222,    43,    44,    45,    46,   296,   297,
     223,    48,    49,    50,    51,   298,   299,   224,    53,    54,
      55,    56,   300,   305,   225,    39,    40,    41,    42,   301,
     309,   226,    43,    44,    45,    46,   285,     0,   227,    48,
      49,    50,    51,   286,     0,   228,    53,    54,    55,    56,
       0,     0,   229,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    39,    40,    41,    42,    43,    44,    45,
      46,   176,   177,    20,    21
};

static const yytype_int16 yycheck[] =
{
      25,    26,    27,    28,    29,    30,    31,    32,    33,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    43,    44,
      45,    46,    11,    48,    49,    50,    51,    43,    44,    45,
      46,    35,    48,    49,    50,    51,    11,     6,     7,     8,
       9,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      14,    14,   237,   238,   239,    39,    40,    41,    42,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    11,    53,
      54,    55,    56,    39,    40,    41,    42,    60,    61,   174,
      49,    64,    65,    11,    14,    49,    49,    53,    54,    55,
      56,     6,     7,     8,     9,    13,     0,    12,   193,    17,
      18,    19,    20,    21,    10,    16,    14,    25,    26,    16,
      13,    29,    62,    63,    17,    18,    19,    20,    21,    49,
      14,    16,    25,    26,    11,    43,    29,    17,    18,    19,
      20,    21,    11,    16,    49,    25,    26,     5,    49,    29,
      43,    49,    49,    10,    62,    13,    11,    15,    17,    18,
      19,    20,    21,    43,    49,    49,    25,    26,    16,    62,
      29,    17,    18,    19,    20,    21,    49,    40,    41,    25,
      26,    11,    62,    29,    43,    10,     6,     7,     8,     9,
      48,   276,    12,    58,    11,    62,    63,    43,   192,    66,
      13,    49,    15,    62,    69,    70,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    10,    62,     6,     7,     8,
       9,   306,    13,    12,    15,     6,     7,     8,     9,    49,
     203,    12,   205,    10,   207,    10,   209,    60,    61,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   254,   255,
     256,   257,   258,   259,   260,   261,   262,     5,    10,   253,
      49,     6,     7,     8,     9,    13,    10,    15,    49,   263,
     244,   245,   246,   247,   248,   249,   250,   251,   252,     6,
       7,     8,     9,     6,     7,     8,     9,    11,   244,   245,
     246,   247,   248,   249,   250,   251,   252,    50,    51,    52,
      53,    54,    55,    56,    49,     5,     5,     8,     9,    11,
      59,    64,    63,    62,    63,    15,    15,    66,    67,    68,
      60,    61,    49,    63,     8,     9,    49,     6,     7,     8,
       9,     8,     9,    12,     6,     7,     8,     9,     8,     9,
      12,     6,     7,     8,     9,    11,    13,    12,     6,     7,
       8,     9,    11,    63,    12,     6,     7,     8,     9,    11,
      63,    12,     6,     7,     8,     9,    11,    63,    12,     6,
       7,     8,     9,    11,    63,    12,     6,     7,     8,     9,
      11,    15,    12,     6,     7,     8,     9,    11,    37,    12,
       6,     7,     8,     9,    11,    -1,    12,     6,     7,     8,
       9,    11,   243,    12,     6,     7,     8,     9,    11,    -1,
      12,     6,     7,     8,     9,    11,    -1,    12,     6,     7,
       8,     9,    11,    -1,    12,     6,     7,     8,     9,    11,
      -1,    12,     6,     7,     8,     9,    11,    -1,    12,     6,
       7,     8,     9,    11,    -1,    12,     6,     7,     8,     9,
      11,    -1,    12,     6,     7,     8,     9,     5,    -1,    12,
       6,     7,     8,     9,    -1,    -1,    12,     6,     7,     8,
       9,    12,    12,    12,     6,     7,     8,     9,    12,    12,
      12,     6,     7,     8,     9,    12,    12,    12,     6,     7,
       8,     9,    12,     5,    12,     6,     7,     8,     9,    12,
       5,    12,     6,     7,     8,     9,    60,    -1,    12,     6,
       7,     8,     9,    60,    -1,    12,     6,     7,     8,     9,
      -1,    -1,    12,     5,     6,     7,     8,     9,     5,     6,
       7,     8,     9,     6,     7,     8,     9,     6,     7,     8,
       9,    60,    61,    62,    63
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_int8 yystos[] =
{
       0,    13,    17,    18,    19,    20,    21,    25,    26,    29,
      43,    62,    66,    67,    76,    77,    78,    79,    80,    81,
      62,    63,    68,    70,    75,    11,    11,    11,    11,    11,
      11,    11,    11,    11,     5,    13,    15,    48,     0,     6,
       7,     8,     9,     6,     7,     8,     9,     5,     6,     7,
       8,     9,     5,     6,     7,     8,     9,    14,    49,    10,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    62,    76,    77,    78,    80,    76,    77,    78,    80,
      76,    77,    78,    80,    76,    77,    78,    80,    76,    77,
      78,    80,    76,    77,    78,    80,    76,    77,    78,    80,
      76,    77,    78,    80,    76,    77,    78,    80,    68,    50,
      51,    52,    53,    54,    55,    56,    64,    72,    74,    62,
      67,    17,    18,    19,    20,    21,    25,    26,    29,    43,
      62,    76,    80,    76,    80,    76,    80,    76,    80,    17,
      18,    19,    20,    21,    25,    26,    29,    43,    62,    77,
      78,    77,    78,    77,    78,    77,    78,    77,    78,    77,
      78,    77,    78,    77,    78,    76,    80,    76,    80,    76,
      80,    76,    80,     5,    15,    75,    60,    61,    69,    70,
      71,    71,    71,    69,    69,    71,    71,    69,    70,    70,
      75,    75,    13,    15,    12,    12,    12,    12,    12,    12,
      12,    12,    12,    49,    12,    49,    12,    49,    12,    49,
      12,    12,    12,    12,    12,    12,    12,    12,    12,    12,
      12,    12,    12,    12,    12,    12,    12,    12,    12,    12,
      49,    49,    49,    49,    14,    10,    10,    10,    10,    10,
      10,    10,    16,    49,    11,    11,    11,    11,    11,    11,
      11,    11,    11,    13,    11,    11,    11,    11,    11,    11,
      11,    11,    11,    13,    72,    68,    72,    71,    71,    71,
      71,    63,    63,    63,    63,     5,    15,    60,    61,    63,
      73,    63,    73,    73,    73,    60,    60,     5,    74,    68,
      68,    16,    14,    16,    12,    12,    12,    12,    12,    12,
      12,    12,    72,    14,    14,     5,    15,    16,    72,     5,
      16
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_int8 yyr1[] =
{
       0,    65,    66,    66,    67,    67,    67,    67,    67,    67,
      67,    67,    68,    68,    69,    69,    70,    70,    71,    71,
      72,    72,    73,    73,    73,    74,    74,    74,    74,    74,
      74,    74,    74,    75,    75,    75,    75,    75,    75,    75,
      75,    75,    75,    75,    75,    76,    76,    77,    77,    78,
      78,    78,    78,    78,    78,    78,    78,    78,    78,    78,
      78,    78,    78,    78,    78,    78,    78,    78,    78,    78,
      79,    79,    79,    79,    79,    79,    79,    79,    79,    79,
      79,    79,    79,    79,    79,    79,    80,    80,    80,    80,
      80,    80,    80,    80,    80,    80,    80,    80,    80,    80,
      80,    80,    80,    80,    80,    80,    80,    81,    81,    81,
      81,    81,    81,    81,    81,    81,    81,    81,    81,    81,
      81,    81,    81
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     1,     3,     5,     8,     7,     4,     5,     2,
       2,     2,     3,     1,     1,     1,     1,     1,     1,     1,
       3,     1,     1,     1,     1,     3,     3,     3,     3,     3,
       3,     3,     1,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     7,     4,     4,     1,     4,
       4,     4,     4,     4,     4,     6,     6,     4,     4,     4,
       4,     6,     6,     4,     4,     4,     4,     4,     4,     1,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     4,     4,     4,     4,
       4,     4,     6,     6,     4,     4,     4,     4,     6,     6,
       4,     4,     4,     4,     4,     4,     1,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (lp, YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
# ifndef YY_LOCATION_PRINT
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, lp); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, PARSER *lp)
{
  FILE *yyoutput = yyo;
  YYUSE (yyoutput);
  YYUSE (lp);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yykind < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yykind], *yyvaluep);
# endif
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, PARSER *lp)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep, lp);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule, PARSER *lp)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)], lp);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule, lp); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, PARSER *lp)
{
  YYUSE (yyvaluep);
  YYUSE (lp);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}






/*----------.
| yyparse.  |
`----------*/

int
yyparse (PARSER *lp)
{
/* The lookahead symbol.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

    /* Number of syntax errors so far.  */
    int yynerrs;

    yy_state_fast_t yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize;

    /* The state stack.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss;
    yy_state_t *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yynerrs = 0;
  yystate = 0;
  yyerrstatus = 0;

  yystacksize = YYINITDEPTH;
  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;


  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex (&yylval, lp);
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 3:
#line 190 "query_parser.y"
                { lp->yy_series.name = (yyvsp[-2].s);
		  (yyval.n) = lp->yy_series.expr;
		  YYACCEPT;
		}
#line 1574 "query_parser.tab.c"
    break;

  case 4:
#line 198 "query_parser.y"
                { lp->yy_np = newmetricquery((yyvsp[-4].s), (yyvsp[-2].n));
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		  YYACCEPT;
		}
#line 1583 "query_parser.tab.c"
    break;

  case 5:
#line 203 "query_parser.y"
                { lp->yy_np = newmetricquery((yyvsp[-7].s), (yyvsp[-5].n));
		  lp->yy_np->time = lp->yy_series.time;
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		  YYACCEPT;
		}
#line 1593 "query_parser.tab.c"
    break;

  case 6:
#line 209 "query_parser.y"
                { lp->yy_np = lp->yy_series.expr = (yyvsp[-5].n); YYACCEPT; }
#line 1599 "query_parser.tab.c"
    break;

  case 7:
#line 211 "query_parser.y"
                { lp->yy_np = lp->yy_series.expr = (yyvsp[-2].n); YYACCEPT; }
#line 1605 "query_parser.tab.c"
    break;

  case 8:
#line 213 "query_parser.y"
                { lp->yy_np = newmetric((yyvsp[-4].s));
		  lp->yy_np->time = lp->yy_series.time;
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		  YYACCEPT;
		}
#line 1615 "query_parser.tab.c"
    break;

  case 9:
#line 219 "query_parser.y"
                { lp->yy_np = newmetric((yyvsp[-1].s));
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		  YYACCEPT;
		}
#line 1624 "query_parser.tab.c"
    break;

  case 10:
#line 224 "query_parser.y"
                { lp->yy_np = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		  YYACCEPT;
		}
#line 1633 "query_parser.tab.c"
    break;

  case 11:
#line 229 "query_parser.y"
                { lp->yy_np = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		  YYACCEPT;
		}
#line 1642 "query_parser.tab.c"
    break;

  case 12:
#line 236 "query_parser.y"
                { lp->yy_np = newnode(N_AND);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_np;
		}
#line 1652 "query_parser.tab.c"
    break;

  case 16:
#line 249 "query_parser.y"
                { lp->yy_np = newnode(N_STRING);
		  lp->yy_np->value = sdsnew((yyvsp[0].s));
		  (yyval.n) = lp->yy_np;
		}
#line 1661 "query_parser.tab.c"
    break;

  case 17:
#line 254 "query_parser.y"
                { lp->yy_np = newnode(N_NAME);
		  lp->yy_np->value = sdsnew((yyvsp[0].s));
		  (yyval.n) = lp->yy_np;
		}
#line 1670 "query_parser.tab.c"
    break;

  case 18:
#line 261 "query_parser.y"
                { lp->yy_np = newnode(N_INTEGER);
		  lp->yy_np->value = sdsnew((yyvsp[0].s));
		  (yyval.n) = lp->yy_np;
		}
#line 1679 "query_parser.tab.c"
    break;

  case 19:
#line 266 "query_parser.y"
                { lp->yy_np = newnode(N_DOUBLE);
		  lp->yy_np->value = sdsnew((yyvsp[0].s));
		  (yyval.n) = lp->yy_np;
		}
#line 1688 "query_parser.tab.c"
    break;

  case 25:
#line 284 "query_parser.y"
                { newinterval(lp, (yyvsp[0].s)); }
#line 1694 "query_parser.tab.c"
    break;

  case 26:
#line 286 "query_parser.y"
                { newtimezone(lp, (yyvsp[0].s)); }
#line 1700 "query_parser.tab.c"
    break;

  case 27:
#line 288 "query_parser.y"
                { newsamples(lp, (yyvsp[0].s)); }
#line 1706 "query_parser.tab.c"
    break;

  case 28:
#line 290 "query_parser.y"
                { newoffset(lp, (yyvsp[0].s)); }
#line 1712 "query_parser.tab.c"
    break;

  case 29:
#line 292 "query_parser.y"
                { newaligntime(lp, (yyvsp[0].s)); }
#line 1718 "query_parser.tab.c"
    break;

  case 30:
#line 294 "query_parser.y"
                { newstarttime(lp, (yyvsp[0].s)); }
#line 1724 "query_parser.tab.c"
    break;

  case 31:
#line 296 "query_parser.y"
                { newendtime(lp, (yyvsp[0].s)); }
#line 1730 "query_parser.tab.c"
    break;

  case 32:
#line 298 "query_parser.y"
                { newrange(lp, (yyvsp[0].s)); }
#line 1736 "query_parser.tab.c"
    break;

  case 33:
#line 303 "query_parser.y"
                { (yyval.n) = lp->yy_np = newtree(N_LT, (yyvsp[-2].n), (yyvsp[0].n)); }
#line 1742 "query_parser.tab.c"
    break;

  case 34:
#line 305 "query_parser.y"
                { (yyval.n) = lp->yy_np = newtree(N_LEQ, (yyvsp[-2].n), (yyvsp[0].n)); }
#line 1748 "query_parser.tab.c"
    break;

  case 35:
#line 307 "query_parser.y"
                { (yyval.n) = lp->yy_np = newtree(N_EQ, (yyvsp[-2].n), (yyvsp[0].n)); }
#line 1754 "query_parser.tab.c"
    break;

  case 36:
#line 309 "query_parser.y"
                { (yyval.n) = lp->yy_np = newtree(N_GEQ, (yyvsp[-2].n), (yyvsp[0].n)); }
#line 1760 "query_parser.tab.c"
    break;

  case 37:
#line 311 "query_parser.y"
                { (yyval.n) = lp->yy_np = newtree(N_GT, (yyvsp[-2].n), (yyvsp[0].n)); }
#line 1766 "query_parser.tab.c"
    break;

  case 38:
#line 313 "query_parser.y"
                { (yyval.n) = lp->yy_np = newtree(N_NEQ, (yyvsp[-2].n), (yyvsp[0].n)); }
#line 1772 "query_parser.tab.c"
    break;

  case 39:
#line 317 "query_parser.y"
                { (yyval.n) = lp->yy_np = newtree(N_REQ, (yyvsp[-2].n), (yyvsp[0].n)); }
#line 1778 "query_parser.tab.c"
    break;

  case 40:
#line 319 "query_parser.y"
                { (yyval.n) = lp->yy_np = newtree(N_RNE, (yyvsp[-2].n), (yyvsp[0].n)); }
#line 1784 "query_parser.tab.c"
    break;

  case 41:
#line 321 "query_parser.y"
                { (yyval.n) = lp->yy_np = newtree(N_GLOB, (yyvsp[-2].n), (yyvsp[0].n)); }
#line 1790 "query_parser.tab.c"
    break;

  case 42:
#line 323 "query_parser.y"
                { (yyval.n) = lp->yy_np = newtree(N_GLOB, (yyvsp[-2].n), (yyvsp[0].n)); }
#line 1796 "query_parser.tab.c"
    break;

  case 43:
#line 327 "query_parser.y"
                { (yyval.n) = lp->yy_np = newtree(N_AND, (yyvsp[-2].n), (yyvsp[0].n)); }
#line 1802 "query_parser.tab.c"
    break;

  case 44:
#line 329 "query_parser.y"
                { (yyval.n) = lp->yy_np = newtree(N_OR, (yyvsp[-2].n), (yyvsp[0].n)); }
#line 1808 "query_parser.tab.c"
    break;

  case 45:
#line 336 "query_parser.y"
                { lp->yy_np = newmetricquery((yyvsp[-6].s), (yyvsp[-4].n));
		  lp->yy_np->time = lp->yy_series.time;
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 1817 "query_parser.tab.c"
    break;

  case 46:
#line 341 "query_parser.y"
                { lp->yy_np = newmetric((yyvsp[-3].s));
		  lp->yy_np->time = lp->yy_series.time;
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 1826 "query_parser.tab.c"
    break;

  case 47:
#line 349 "query_parser.y"
                { lp->yy_np = newmetricquery((yyvsp[-3].s), (yyvsp[-1].n));
                  (yyval.n) = lp->yy_series.expr = lp->yy_np;
                }
#line 1834 "query_parser.tab.c"
    break;

  case 48:
#line 353 "query_parser.y"
                { lp->yy_np = newmetric((yyvsp[0].s)); /* TODO: perhaps newsidexpr()? */
                  (yyval.n) = lp->yy_series.expr = lp->yy_np;
                }
#line 1842 "query_parser.tab.c"
    break;

  case 49:
#line 360 "query_parser.y"
                { lp->yy_np = newnode(N_RATE);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 1851 "query_parser.tab.c"
    break;

  case 50:
#line 365 "query_parser.y"
                { lp->yy_np = newnode(N_RATE);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 1860 "query_parser.tab.c"
    break;

  case 51:
#line 370 "query_parser.y"
                { lp->yy_np = newnode(N_MAX);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 1869 "query_parser.tab.c"
    break;

  case 52:
#line 375 "query_parser.y"
                { lp->yy_np = newnode(N_MAX);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 1878 "query_parser.tab.c"
    break;

  case 53:
#line 380 "query_parser.y"
                { lp->yy_np = newnode(N_MIN);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 1887 "query_parser.tab.c"
    break;

  case 54:
#line 385 "query_parser.y"
                { lp->yy_np = newnode(N_MIN);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 1896 "query_parser.tab.c"
    break;

  case 55:
#line 390 "query_parser.y"
                { double		mult;
		  struct pmUnits	units;
		  char			*errmsg;
		
		  lp->yy_np = newnode(N_RESCALE);
		  lp->yy_np->left = (yyvsp[-3].n);
		  if (pmParseUnitsStr((yyvsp[-1].s), &units, &mult, &errmsg) < 0) {
		      gramerr(lp, "Illegal units:", NULL, errmsg);
		      free(errmsg);
		      series_error(lp, NULL);
		      return -1;
		  }
		  lp->yy_np->right = newnode(N_SCALE);
		  lp->yy_np->right->meta.units = units;	/* struct assign */
		  lp->yy_np->right->value = (yyvsp[-1].s);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 1918 "query_parser.tab.c"
    break;

  case 56:
#line 408 "query_parser.y"
                { double		mult;
		  struct pmUnits	units;
		  char			*errmsg;
		
		  lp->yy_np = newnode(N_RESCALE);
		  lp->yy_np->left = (yyvsp[-3].n);
		  if (pmParseUnitsStr((yyvsp[-1].s), &units, &mult, &errmsg) < 0) {
		      gramerr(lp, "Illegal units:", NULL, errmsg);
		      free(errmsg);
		      series_error(lp, NULL);
		      return -1;
		  }
		  lp->yy_np->right = newnode(N_SCALE);
		  lp->yy_np->right->meta.units = units;	/* struct assign */
		  lp->yy_np->right->value = (yyvsp[-1].s);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 1940 "query_parser.tab.c"
    break;

  case 57:
#line 426 "query_parser.y"
                { lp->yy_np = newnode(N_ABS);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 1949 "query_parser.tab.c"
    break;

  case 58:
#line 431 "query_parser.y"
                { lp->yy_np = newnode(N_ABS);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 1958 "query_parser.tab.c"
    break;

  case 59:
#line 436 "query_parser.y"
                { lp->yy_np = newnode(N_FLOOR);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 1967 "query_parser.tab.c"
    break;

  case 60:
#line 441 "query_parser.y"
                { lp->yy_np = newnode(N_FLOOR);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 1976 "query_parser.tab.c"
    break;

  case 61:
#line 446 "query_parser.y"
                { lp->yy_np = newnode(N_LOG);
		  lp->yy_np->left = (yyvsp[-3].n);
		  lp->yy_np->right = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 1986 "query_parser.tab.c"
    break;

  case 62:
#line 452 "query_parser.y"
                { lp->yy_np = newnode(N_LOG);
		  lp->yy_np->left = (yyvsp[-3].n);
		  lp->yy_np->right = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 1996 "query_parser.tab.c"
    break;

  case 63:
#line 458 "query_parser.y"
                { lp->yy_np = newnode(N_LOG);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2005 "query_parser.tab.c"
    break;

  case 64:
#line 463 "query_parser.y"
                { lp->yy_np = newnode(N_LOG);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2014 "query_parser.tab.c"
    break;

  case 65:
#line 468 "query_parser.y"
                { lp->yy_np = newnode(N_SQRT);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2023 "query_parser.tab.c"
    break;

  case 66:
#line 473 "query_parser.y"
                { lp->yy_np = newnode(N_SQRT);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2032 "query_parser.tab.c"
    break;

  case 67:
#line 478 "query_parser.y"
                { lp->yy_np = newnode(N_ROUND);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2041 "query_parser.tab.c"
    break;

  case 68:
#line 483 "query_parser.y"
                { lp->yy_np = newnode(N_ROUND);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2050 "query_parser.tab.c"
    break;

  case 69:
#line 488 "query_parser.y"
                { lp->yy_np = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2058 "query_parser.tab.c"
    break;

  case 70:
#line 495 "query_parser.y"
                { lp->yy_np = newnode(N_PLUS);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2068 "query_parser.tab.c"
    break;

  case 71:
#line 501 "query_parser.y"
                { lp->yy_np = newnode(N_PLUS);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2078 "query_parser.tab.c"
    break;

  case 72:
#line 507 "query_parser.y"
                { lp->yy_np = newnode(N_PLUS);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2088 "query_parser.tab.c"
    break;

  case 73:
#line 513 "query_parser.y"
                { lp->yy_np = newnode(N_PLUS);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2098 "query_parser.tab.c"
    break;

  case 74:
#line 519 "query_parser.y"
                { lp->yy_np = newnode(N_MINUS);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2108 "query_parser.tab.c"
    break;

  case 75:
#line 525 "query_parser.y"
                { lp->yy_np = newnode(N_MINUS);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2118 "query_parser.tab.c"
    break;

  case 76:
#line 531 "query_parser.y"
                { lp->yy_np = newnode(N_MINUS);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2128 "query_parser.tab.c"
    break;

  case 77:
#line 537 "query_parser.y"
                { lp->yy_np = newnode(N_MINUS);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2138 "query_parser.tab.c"
    break;

  case 78:
#line 543 "query_parser.y"
                { lp->yy_np = newnode(N_STAR);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2148 "query_parser.tab.c"
    break;

  case 79:
#line 549 "query_parser.y"
                { lp->yy_np = newnode(N_STAR);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2158 "query_parser.tab.c"
    break;

  case 80:
#line 555 "query_parser.y"
                { lp->yy_np = newnode(N_STAR);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2168 "query_parser.tab.c"
    break;

  case 81:
#line 561 "query_parser.y"
                { lp->yy_np = newnode(N_STAR);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2178 "query_parser.tab.c"
    break;

  case 82:
#line 567 "query_parser.y"
                { lp->yy_np = newnode(N_SLASH);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2188 "query_parser.tab.c"
    break;

  case 83:
#line 573 "query_parser.y"
                { lp->yy_np = newnode(N_SLASH);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2198 "query_parser.tab.c"
    break;

  case 84:
#line 579 "query_parser.y"
                { lp->yy_np = newnode(N_SLASH);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2208 "query_parser.tab.c"
    break;

  case 85:
#line 585 "query_parser.y"
                { lp->yy_np = newnode(N_SLASH);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2218 "query_parser.tab.c"
    break;

  case 86:
#line 594 "query_parser.y"
                { lp->yy_np = newnode(N_RATE);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2227 "query_parser.tab.c"
    break;

  case 87:
#line 599 "query_parser.y"
                { lp->yy_np = newnode(N_RATE);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2236 "query_parser.tab.c"
    break;

  case 88:
#line 604 "query_parser.y"
                { lp->yy_np = newnode(N_MAX);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2245 "query_parser.tab.c"
    break;

  case 89:
#line 609 "query_parser.y"
                { lp->yy_np = newnode(N_MAX);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2254 "query_parser.tab.c"
    break;

  case 90:
#line 614 "query_parser.y"
                { lp->yy_np = newnode(N_MIN);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2263 "query_parser.tab.c"
    break;

  case 91:
#line 619 "query_parser.y"
                { lp->yy_np = newnode(N_MIN);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2272 "query_parser.tab.c"
    break;

  case 92:
#line 624 "query_parser.y"
                { double		mult;
		  struct pmUnits	units;
		  char			*errmsg;
		
		  lp->yy_np = newnode(N_RESCALE);
		  lp->yy_np->left = (yyvsp[-3].n);
		  if (pmParseUnitsStr((yyvsp[-1].s), &units, &mult, &errmsg) < 0) {
		      gramerr(lp, "Illegal units:", NULL, errmsg);
		      free(errmsg);
		      series_error(lp, NULL);
		      return -1;
		  }
		  lp->yy_np->right = newnode(N_SCALE);
		  lp->yy_np->right->meta.units = units;	/* struct assign */
		  lp->yy_np->right->value = (yyvsp[-1].s);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2294 "query_parser.tab.c"
    break;

  case 93:
#line 642 "query_parser.y"
                { double		mult;
		  struct pmUnits	units;
		  char			*errmsg;
		
		  lp->yy_np = newnode(N_RESCALE);
		  lp->yy_np->left = (yyvsp[-3].n);
		  if (pmParseUnitsStr((yyvsp[-1].s), &units, &mult, &errmsg) < 0) {
		      gramerr(lp, "Illegal units:", NULL, errmsg);
		      free(errmsg);
		      series_error(lp, NULL);
		      return -1;
		  }
		  lp->yy_np->right = newnode(N_SCALE);
		  lp->yy_np->right->meta.units = units;	/* struct assign */
		  lp->yy_np->right->value = (yyvsp[-1].s);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2316 "query_parser.tab.c"
    break;

  case 94:
#line 660 "query_parser.y"
                { lp->yy_np = newnode(N_ABS);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2325 "query_parser.tab.c"
    break;

  case 95:
#line 665 "query_parser.y"
                { lp->yy_np = newnode(N_ABS);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2334 "query_parser.tab.c"
    break;

  case 96:
#line 670 "query_parser.y"
                { lp->yy_np = newnode(N_FLOOR);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2343 "query_parser.tab.c"
    break;

  case 97:
#line 675 "query_parser.y"
                { lp->yy_np = newnode(N_FLOOR);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2352 "query_parser.tab.c"
    break;

  case 98:
#line 680 "query_parser.y"
                { lp->yy_np = newnode(N_LOG);
		  lp->yy_np->left = (yyvsp[-3].n);
		  lp->yy_np->right = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2362 "query_parser.tab.c"
    break;

  case 99:
#line 686 "query_parser.y"
                { lp->yy_np = newnode(N_LOG);
		  lp->yy_np->left = (yyvsp[-3].n);
		  lp->yy_np->right = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2372 "query_parser.tab.c"
    break;

  case 100:
#line 692 "query_parser.y"
                { lp->yy_np = newnode(N_LOG);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2381 "query_parser.tab.c"
    break;

  case 101:
#line 697 "query_parser.y"
                { lp->yy_np = newnode(N_LOG);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2390 "query_parser.tab.c"
    break;

  case 102:
#line 702 "query_parser.y"
                { lp->yy_np = newnode(N_SQRT);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2399 "query_parser.tab.c"
    break;

  case 103:
#line 707 "query_parser.y"
                { lp->yy_np = newnode(N_SQRT);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2408 "query_parser.tab.c"
    break;

  case 104:
#line 712 "query_parser.y"
                { lp->yy_np = newnode(N_ROUND);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2417 "query_parser.tab.c"
    break;

  case 105:
#line 717 "query_parser.y"
                { lp->yy_np = newnode(N_ROUND);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2426 "query_parser.tab.c"
    break;

  case 106:
#line 722 "query_parser.y"
                { lp->yy_np = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2434 "query_parser.tab.c"
    break;

  case 107:
#line 728 "query_parser.y"
                { lp->yy_np = newnode(N_PLUS);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2444 "query_parser.tab.c"
    break;

  case 108:
#line 734 "query_parser.y"
                { lp->yy_np = newnode(N_PLUS);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2454 "query_parser.tab.c"
    break;

  case 109:
#line 740 "query_parser.y"
                { lp->yy_np = newnode(N_PLUS);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2464 "query_parser.tab.c"
    break;

  case 110:
#line 746 "query_parser.y"
                { lp->yy_np = newnode(N_PLUS);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2474 "query_parser.tab.c"
    break;

  case 111:
#line 752 "query_parser.y"
                { lp->yy_np = newnode(N_MINUS);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2484 "query_parser.tab.c"
    break;

  case 112:
#line 758 "query_parser.y"
                { lp->yy_np = newnode(N_MINUS);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2494 "query_parser.tab.c"
    break;

  case 113:
#line 764 "query_parser.y"
                { lp->yy_np = newnode(N_MINUS);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2504 "query_parser.tab.c"
    break;

  case 114:
#line 770 "query_parser.y"
                { lp->yy_np = newnode(N_MINUS);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2514 "query_parser.tab.c"
    break;

  case 115:
#line 776 "query_parser.y"
                { lp->yy_np = newnode(N_STAR);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2524 "query_parser.tab.c"
    break;

  case 116:
#line 782 "query_parser.y"
                { lp->yy_np = newnode(N_STAR);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2534 "query_parser.tab.c"
    break;

  case 117:
#line 788 "query_parser.y"
                { lp->yy_np = newnode(N_STAR);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2544 "query_parser.tab.c"
    break;

  case 118:
#line 794 "query_parser.y"
                { lp->yy_np = newnode(N_STAR);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2554 "query_parser.tab.c"
    break;

  case 119:
#line 800 "query_parser.y"
                { lp->yy_np = newnode(N_SLASH);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2564 "query_parser.tab.c"
    break;

  case 120:
#line 806 "query_parser.y"
                { lp->yy_np = newnode(N_SLASH);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2574 "query_parser.tab.c"
    break;

  case 121:
#line 812 "query_parser.y"
                { lp->yy_np = newnode(N_SLASH);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2584 "query_parser.tab.c"
    break;

  case 122:
#line 818 "query_parser.y"
                { lp->yy_np = newnode(N_SLASH);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2594 "query_parser.tab.c"
    break;


#line 2598 "query_parser.tab.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (lp, YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, lp);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, lp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if !defined yyoverflow
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (lp, YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif


/*-----------------------------------------------------.
| yyreturn -- parsing is finished, return the result.  |
`-----------------------------------------------------*/
yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, lp);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, lp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 912 "query_parser.y"


/* function table for lexer */
static const struct {
    int		f_type;
    int		f_namelen;
    char	*f_name;
} func[] = {
    { L_AVG,		sizeof("avg")-1,	"avg" },
    { L_COUNT,		sizeof("count")-1,	"count" },
    { L_MAX,		sizeof("max")-1,	"max" },
    { L_MIN,		sizeof("min")-1,	"min" },
    { L_SUM,		sizeof("sum")-1,	"sum" },
    { L_RATE,		sizeof("rate")-1,	"rate" },
    { L_ABS,		sizeof("abs")-1,	"abs" },
    { L_FLOOR,		sizeof("floor")-1,	"floor" },
    { L_LOG,		sizeof("log")-1,	"log" },
    { L_SQRT,		sizeof("sqrt")-1,	"sqrt" },
    { L_ROUND,		sizeof("round")-1,	"round" },
    { L_RESCALE,	sizeof("rescale")-1,	"rescale" },
    { L_UNDEF,		0,			NULL }
};

static struct {
    int         ltype;
    int         ntype;
    char        *long_name;
    char        *short_name;
} typetab[] = {
    { L_UNDEF,		0,		"UNDEF",	NULL },
    { L_ERROR,		0,		"ERROR",	NULL },
    { L_EOS,		0,		"EOS",		NULL },
    { L_INTEGER,	N_INTEGER,	"INTEGER",	NULL },
    { L_DOUBLE,		N_DOUBLE,	"DOUBLE",	NULL },
    { L_NAME,		N_NAME,		"NAME",		NULL },
    { L_NAME,		N_METRIC,	"METRIC",	NULL },
    { L_NAME,		N_QUERY,	"QUERY",	NULL },
    { L_PLUS,		N_PLUS,		"PLUS",		"+" },
    { L_MINUS,		N_MINUS,	"MINUS",	"-" },
    { L_STAR,		N_STAR,		"STAR",		"*" },
    { L_SLASH,		N_SLASH,	"SLASH",	"/" },
    { L_LPAREN,		0,		"LPAREN",	"(" },
    { L_RPAREN,		0,		"RPAREN",	")" },
    { L_LBRACE,		0,		"LBRACE",	"{" },
    { L_RBRACE,		0,		"RBRACE",	"}" },
    { L_TYPE,		0,		"TYPE",		NULL },
    { L_SEMANTICS,	0,		"SEMANTICS",	NULL },
    { L_UNITS,		0,		"UNITS",	NULL },
    { L_ASSIGN,		0,		"ASSIGN",	"=" },
    { L_COMMA,		0,		"COMMA",	"," },
    { L_STRING,		0,		"STRING",	"\"" },
    { L_ABS,		N_ABS,		"ABS",		NULL },
    { L_FLOOR,		N_FLOOR,	"FLOOR",	NULL },
    { N_LOG,		N_LOG,		"LOG",		NULL },
    { N_SQRT,		N_SQRT,		"SQRT",		NULL },
    { N_ROUND,		N_ROUND,	"ROUND",	NULL },
    { L_AVG,		N_AVG,		"AVG",		NULL },
    { L_COUNT,		N_COUNT,	"COUNT",	NULL },
    { L_DELTA,		N_DELTA,	"DELTA",	NULL },
    { L_MAX,		N_MAX,		"MAX",		NULL },
    { L_MIN,		N_MIN,		"MIN",		NULL },
    { L_SUM,		N_SUM,		"SUM",		NULL },
    { L_ANON,		N_ANON,		"ANON",		NULL },
    { L_RATE,		N_RATE,		"RATE",		NULL },
    { L_INSTANT,	N_INSTANT,	"INSTANT",	NULL },
    { L_MKCONST,	0,		"MKCONST",	NULL },
    { L_RESCALE,	N_RESCALE,	"RESCALE",	NULL },
    { 0,		N_SCALE,	"SCALE",	NULL },
    { L_DEFINED,	N_DEFINED,	"DEFINED",	NULL },
    { L_INTERVAL,	N_INTERVAL,	"INTERVAL",	NULL },
    { L_START,		N_START,	"START",	NULL },
    { L_FINISH,		N_FINISH,	"FINISH",	NULL },
    { L_TIMEZONE,	N_TIMEZONE,	"TIMEZONE",	"TZ" },
    { L_SAMPLES,	N_SAMPLES,	"SAMPLES",	NULL },
    { L_OFFSET,		N_OFFSET,	"OFFSET",	NULL },
    { L_LT,		N_LT,		"LT",		"<" },
    { L_LEQ,		N_LEQ,		"LEQ",		"<=" },
    { L_EQ,		N_EQ,		"EQ",		"==" },
    { L_GLOB,		N_GLOB,		"GLOB",		"~~" },
    { L_GEQ,		N_GEQ,		"GEQ",		">=" },
    { L_GT,		N_GT,		"GT",		">" },
    { L_NEQ,		N_NEQ,		"NEQ",		"!=" },
    { L_REQ,		N_REQ,		"REQ",		"=~" },
    { L_RNE,		N_RNE,		"RNE",		"!~" },
    { L_AND,		N_AND,		"AND",		"&&" },
    { L_OR,		N_OR,		"OR",		"||" },
    { 0,		N_NEG,		"NEG",		"-" },
    { -1,		-1,		NULL,		NULL }
};

/* full name for all node types */
static char *
n_type_str(int type)
{
    int		i;
    static char n_eh_str[32];	/* big enough for "unknown type XXXXXXXXXXX!" */

    for (i = 0; typetab[i].ntype != -1; i++)
	if (type == typetab[i].ntype)
	    return typetab[i].long_name;
    pmsprintf(n_eh_str, sizeof(n_eh_str), "unknown type %d!", type);
    return n_eh_str;
}

/* short string for the operator node types */
static char *
n_type_c(int type)
{
    int		i;
    static char n_eh_c[20]; /* big enough for "op XXXXXXXXXXX!" */

    for (i = 0; typetab[i].ntype != -1; i++)
	if (type == typetab[i].ntype)
	    return typetab[i].short_name;
    pmsprintf(n_eh_c, sizeof(n_eh_c), "op %d!", type);
    return n_eh_c;
}

/* full name for all lex types */
static char *
l_type_str(int type)
{
    int		i;
    static char l_eh_str[32];	/* big enough for "unknown type XXXXXXXXXXX!" */

    for (i = 0; typetab[i].ltype != -1; i++)
	if (type == typetab[i].ltype)
	    return typetab[i].long_name;
    pmsprintf(l_eh_str, sizeof(l_eh_str), "unknown type %d!", type);
    return l_eh_str;
}

static node_t *
newnode(int type)
{
    node_t	*np;

    if ((np = (node_t *)calloc(1, sizeof(node_t))) == NULL) {
	pmNoMem("pmSeries: newnode", sizeof(node_t), PM_FATAL_ERR);
	/*NOTREACHED*/
    }
    np->type = type;
    return np;
}

static node_t *
newtree(int type, node_t *left, node_t *right)
{
    node_t	*tree = newnode(type);

    tree->left = left;
    tree->right = right;
    return tree;
}

static node_t *
newmetric(char *name)
{
    node_t	*node;
    char	*re;

    /* enable globbing if string contains a non-escaped '*' */
    if ((re = strchr(name, '*')) != NULL &&
	(re == name || (re[-1] != '%' && re[-1] != '\\')))
	node = newnode(N_GLOB);
    else
	node = newnode(N_EQ);

    node->left = newnode(N_NAME);
    node->left->value = sdsnew("metric.name");
    node->right = newnode(N_STRING);
    node->right->value = sdsnew(name);
    return node;
}

static node_t *
newmetricquery(char *name, node_t *query)
{
    node_t	*root = newnode(N_AND);
    node_t	*metric = newmetric(name);

    root->left = metric;
    root->right = query;
    return root;
}

static void
newinterval(PARSER *lp, const char *string)
{
    timing_t	*tp = &lp->yy_series.time;
    char	*error;
    int		sts;

    if ((sts = pmParseInterval(string, &tp->delta, &error)) < 0) {
	lp->yy_error = sts;
	lp->yy_errstr = sdscatfmt(sdsempty(),
		"Cannot parse time delta with pmParseInterval:\n%s", error);
	free(error);
    } else {
	tp->window.delta = sdsnew(string);
    }
}

static void
parsetime(PARSER *lp, struct timeval *result, const char *string)
{
    struct timeval start = { 0, 0 };
    struct timeval end = { INT_MAX, 0 };
    char	*error;
    int		sts;

    if ((sts = __pmParseTime(string, &start, &end, result, &error)) < 0) {
	lp->yy_error = sts;
	lp->yy_errstr = sdscatfmt(sdsempty(),
		"Cannot parse time with __pmParseTime:\n%s", error);
	free(error);
    }
}

static void
newstarttime(PARSER *lp, const char *string)
{
    timing_t	*tp = &lp->yy_series.time;

    parsetime(lp, &tp->start, string);
    if (!lp->yy_error)
	tp->window.start = sdsnew(string);
#if 0
    if (!lp->yy_error)
fprintf(stderr, "START: %.64g\n", pmtimevalToReal(result));
    else
fprintf(stderr, "ERROR (start: %s): %s\n", string, lp->yy_errstr);
#endif
}

static void
newendtime(PARSER *lp, const char *string)
{
    timing_t	*tp = &lp->yy_series.time;

    parsetime(lp, &tp->end, string);
    if (!lp->yy_error)
	tp->window.end = sdsnew(string);
#if 0
    if (!lp->yy_error)
fprintf(stderr, "END: %.64g\n", pmtimevalToReal(result));
    else
fprintf(stderr, "ERROR (end: %s): %s\n", string, lp->yy_errstr);
#endif
}

static void
newrange(PARSER *lp, const char *string)
{
    timing_t	*tp = &lp->yy_series.time;
    char	*error;
    int		sts;

    if ((sts = pmParseInterval(string, &tp->start, &error)) < 0) {
	lp->yy_error = sts;
	lp->yy_errstr = sdscatfmt(sdsempty(),
		"Cannot parse range with pmParseInterval:\n%s", error);
	lp->yy_error = sts;
	free(error);
    } else {
	struct timeval offset;
	gettimeofday(&offset, NULL);
	tsub(&offset, &tp->start);
	tp->start = offset;
	tp->end.tv_sec = INT_MAX;
	tp->window.range = sdsnew(string);
    }
}

static void
newaligntime(PARSER *lp, const char *string)
{
    timing_t	*tp = &lp->yy_series.time;

    parsetime(lp, &tp->align, string);
    if (!lp->yy_error)
	tp->window.align = sdsnew(string);
#if 0
    if (!lp->yy_error)
fprintf(stderr, "ALIGN: %.64g\n", pmtimevalToReal(result));
    else
fprintf(stderr, "ERROR (align: %s): %s\n", string, lp->yy_errstr);
#endif
}

static void
newtimezone(PARSER *lp, const char *string)
{
    timing_t	*tp = &lp->yy_series.time;
    char	e[PM_MAXERRMSGLEN];
    int		sts;

    if ((sts = pmNewZone(string)) < 0) {
	lp->yy_error = sts;
	lp->yy_errstr = sdscatfmt(sdsempty(),
		"Cannot parse timezone with pmNewZone:\n\"%s\" - %s",
		string, pmErrStr_r(sts, e, sizeof(e)));
    } else {
	tp->zone = sts;
	tp->window.zone = sdsnew(string);
    }
}

static void
newsamples(PARSER *lp, const char *string)
{
    timing_t	*tp = &lp->yy_series.time;
    int		sts;

    if ((sts = atoi(string)) < 0) {
	lp->yy_error = -EINVAL;
	lp->yy_errstr = sdscatfmt(sdsempty(),
		"Invalid sample count requested - \"%s\"", string);
    } else {
	tp->count = sts;
	tp->window.count = sdsnew(string);
    }
}

static void
newoffset(PARSER *lp, const char *string)
{
    timing_t	*tp = &lp->yy_series.time;
    int		sts;

    if ((sts = atoi(string)) < 0) {
	lp->yy_error = -EINVAL;
	lp->yy_errstr = sdscatfmt(sdsempty(),
		"Invalid sample offset requested - \"%s\"", string);
    } else {
	tp->offset = sts;
	tp->window.offset = sdsnew(string);
    }
}

static void
gramerr(PARSER *lp, const char *phrase, const char *pos, char *arg)
{
   char errmsg[256];

   /* unless lexer has already found something amiss ... */
   if (lp->yy_errstr == NULL) {
	if (pos == NULL)
	    pmsprintf(errmsg, sizeof(errmsg), "%s '%s'", phrase, arg);
	else
	    pmsprintf(errmsg, sizeof(errmsg), "%s expected to %s %s", phrase, pos, arg);
	lp->yy_errstr = sdsnew(errmsg);
   }
}

/* Construct error message buffer for syntactic error */
static char *
parseError(const char *spec, const char *point, const char *msg)
{
    size_t	need = 2 * strlen(spec) + strlen(msg) + 8;
    const char	*p;
    char	*q, *result;

    if ((result = malloc(need)) == NULL)
	return NULL;
    q = result;

    for (p = spec; *p != '\0'; p++)
	*q++ = *p;
    *q++ = '\n';
    for (p = spec; p != point; p++)
	*q++ = isgraph((int)*p) ? ' ' : *p;
    snprintf(q, need - (q - result), "^ -- ");
    q += 5;
    for (p = msg; *p != '\0'; p++)
	*q++ = *p;
    *q++ = '\n';
    *q = '\0';
    return result;
}

static int
series_error(PARSER *lp, const char *s)
{
    char	*msg;

    msg = parseError(lp->yy_base, lp->yy_lexicon, s ? s : "syntax error");
    lp->yy_errstr = sdscatfmt(sdsempty(), "cannot parse given string\n\n%s", msg);
    free(msg);

    lp->yy_series.expr = NULL;
    lp->yy_error = -EINVAL;
    return 0;
}

static int
yyerror(PARSER *lp, const char *s)
{
    return series_error(lp, s);
}

static void
unget(PARSER *lp, int c)
{
    lp->yy_lexpeek = c;
}

static int
get(PARSER *lp)
{
    int		c;

    if (lp->yy_lexpeek != 0) {
	c = lp->yy_lexpeek;
	lp->yy_lexpeek = 0;
	return c;
    }
    c = *lp->yy_input;
    if (c == '\0')
	return EOF;
    lp->yy_input++;
    return c;
}

static int
series_lex(YYSTYPE *lvalp, PARSER *lp)
{
    char	*p = lp->yy_tokbuf;
    int		ltype = L_UNDEF;
    int		c, i, len;
    int		firstch = 1;
    int		ret = L_UNDEF;

    for ( ; ret == L_UNDEF; ) {
	c = get(lp);
	if (firstch) {
	    if (isspace((int)c)) continue;
	    lp->yy_lexicon = &lp->yy_input[-1];
	    firstch = 0;
	}
	if (c == EOF) {
	    if (ltype != L_UNDEF) {
		/* force end of last token */
		c = 0;
	    }
	    else {
		/* really the end of the input buffer */
		ret = L_EOS;
		break;
	    }
	}
	if (p == NULL) {
	    lp->yy_tokbuflen = 128;
	    if ((p = (char *)malloc(lp->yy_tokbuflen)) == NULL) {
		lp->yy_errstr = sdscatfmt(sdsempty(),
				"cannot allocate token buffer (length=%lld)",
				(long long)lp->yy_tokbuflen);
		lp->yy_error = -ENOMEM;
		ret = L_ERROR;
		break;
	    }
	    lp->yy_tokbuf = p;
	}
	else if (p >= &lp->yy_tokbuf[lp->yy_tokbuflen]) {
	    len = p - lp->yy_tokbuf;
	    lp->yy_tokbuflen *= 2;
	    if (!(p = (char *)realloc(lp->yy_tokbuf, lp->yy_tokbuflen))) {
		lp->yy_errstr = sdscatfmt(sdsempty(),
				"cannot reallocate token buffer (length=%lld)",
				(long long)lp->yy_tokbuflen);
		lp->yy_error = -ENOMEM;
		ret = L_ERROR;
		break;
	    }
	    lp->yy_tokbuf = p;
	    p = &lp->yy_tokbuf[len];
	}

	*p++ = (char)c;

	if (ltype == L_UNDEF) {
	    if (isdigit((int)c))
		ltype = L_INTEGER;
	    else if (c == '.')
		ltype = L_DOUBLE;
	    else if (isalpha((int)c))
		ltype = L_NAME;
	    else {
		switch (c) {
		    case '+':
			*p = '\0';
			ret = L_PLUS;
			break;

		    case '-':
			*p = '\0';
			ret = L_MINUS;
			break;

		    case '*':
			*p = '\0';
			ret = L_STAR;
			break;

		    case '/':
			*p = '\0';
			ret = L_SLASH;
			break;

		    case '(':
			*p = '\0';
			ret = L_LPAREN;
			break;

		    case ')':
			*p = '\0';
			ret = L_RPAREN;
			break;

		    case '{':
			*p = '\0';
			ret = L_LBRACE;
			break;

		    case '}':
			*p = '\0';
			ret = L_RBRACE;
			break;

		    case '[':
			*p = '\0';
			ret = L_LSQUARE;
			break;

		    case ']':
			*p = '\0';
			ret = L_RSQUARE;
			break;

		    case '<':
			ltype = L_LT;
			break;

		    case '=':
			ltype = L_EQ;
			break;

		    case '~':
			ltype = L_GLOB;
			break;

		    case '>':
			ltype = L_GT;
			break;

		    case '!':
			ltype = L_NEQ;
			break;

		    case '&':
			ltype = L_AND;
			break;

		    case '|':
			ltype = L_OR;
			break;

		    case ':':
			*p = '\0';
			ret = L_COLON;
			break;

		    case ',':
			*p = '\0';
			ret = L_COMMA;
			break;

		    case '"':
			ltype = L_STRING;
			break;

		    default:
			*p = '\0';
			lp->yy_errstr = sdsnew("Illegal character");
			lp->yy_error = -EINVAL;
			ret = L_ERROR;
			break;
		}
	    }
	}
	else {
	    if (ltype == L_INTEGER) {
		if (c == '.') {
		    ltype = L_DOUBLE;
		}
		else if (isalpha((int)c)) {
		    ltype = L_RANGE;
		}
		else if (!isdigit((int)c)) {
		    char	*endptr;
		    __uint64_t	check;

		    unget(lp, c);
		    p[-1] = '\0';
		    check = strtoull(lp->yy_tokbuf, &endptr, 10);
		    if (*endptr != '\0' || check > 0xffffffffUL) {
			lp->yy_errstr = sdsnew("Constant value too large");
			lp->yy_error = -EINVAL;
			ret = L_ERROR;
			break;
		    }
		    if ((lvalp->s = sdsnew(lp->yy_tokbuf)) == NULL) {
			lp->yy_errstr = sdsnew("dup() for INTEGER failed");
			lp->yy_error = -ENOMEM;
			ret = L_ERROR;
			break;
		    }
		    ret = L_INTEGER;
		    break;
		}
	    }
	    else if (ltype == L_RANGE) {
		if (!isalpha((int)c)) {
		    unget(lp, c);
		    p[-1] = '\0';
		    if ((lvalp->s = sdsnew(lp->yy_tokbuf)) == NULL) {
			lp->yy_errstr = sdsnew("dup() for RANGE failed");
			lp->yy_error = -ENOMEM;
			ret = L_ERROR;
			break;
		    }
		    ret = L_RANGE;
		    break;
		}
	    }
	    else if (ltype == L_DOUBLE) {
		if (!isdigit((int)c)) {
		    unget(lp, c);
		    p[-1] = '\0';
		    if ((lvalp->s = sdsnew(lp->yy_tokbuf)) == NULL) {
			lp->yy_errstr = sdsnew("dup() for DOUBLE failed");
			lp->yy_error = -ENOMEM;
			ret = L_ERROR;
			break;
		    }
		    ret = L_DOUBLE;
		    break;
		}
	    }
	    else if (ltype == L_NAME) {
		if (isalpha((int)c) || isdigit((int)c) ||
		    c == '_' || c == '.' || c == '*' || c == '%' || c == '\\')
		    continue;
		if (c == '(') {
		    /* check for functions ... */
		    len = p - lp->yy_tokbuf - 1;
		    for (i = 0; func[i].f_name != NULL; i++) {
			if (len == func[i].f_namelen &&
			    strncmp(lp->yy_tokbuf, func[i].f_name, len) == 0) {
			    unget(lp, c);
			    p[-1] = '\0';
			    ret = func[i].f_type;
			    break;
			}
		    }
		    if (func[i].f_name != NULL) {
			/* match func name */
			break;
		    }
		}

		/* current character is end of name */
		unget(lp, c);
		p[-1] = '\0';
		if (strcmp(lp->yy_tokbuf, "type") == 0) {
		    ret = L_TYPE;
		    break;
		}
		else if (strcmp(lp->yy_tokbuf, "semantics") == 0) {
		    ret = L_SEMANTICS;
		    break;
		}
		else if (strcmp(lp->yy_tokbuf, "units") == 0) {
		    ret = L_UNITS;
		    break;
		}
		else if (strcmp(lp->yy_tokbuf, "interval") == 0 ||
			 strcmp(lp->yy_tokbuf, "delta") == 0) {
		    ret = L_INTERVAL;
		    break;
		}
		else if (strcmp(lp->yy_tokbuf, "timezone") == 0 ||
			 strcmp(lp->yy_tokbuf, "tz") == 0) {
		    ret = L_TIMEZONE;
		    break;
		}
		else if (strcmp(lp->yy_tokbuf, "start") == 0 ||
			 strcmp(lp->yy_tokbuf, "begin") == 0) {
		    ret = L_START;
		    break;
		}
		else if (strcmp(lp->yy_tokbuf, "finish") == 0 ||
			 strcmp(lp->yy_tokbuf, "end") == 0) {
		    ret = L_FINISH;
		    break;
		}
		else if (strcmp(lp->yy_tokbuf, "samples") == 0 ||
			 strcmp(lp->yy_tokbuf, "count") == 0) {
		    ret = L_SAMPLES;
		    break;
		}
		else if (strcmp(lp->yy_tokbuf, "offset") == 0 ||
			 strcmp(lp->yy_tokbuf, "from") == 0) {
		    ret = L_OFFSET;
		    break;
		}
		else if (strcmp(lp->yy_tokbuf, "align") == 0 ||
			 strcmp(lp->yy_tokbuf, "alignment") == 0) {
		    ret = L_ALIGN;
		    break;
		}
		if ((lvalp->s = sdsnew(lp->yy_tokbuf)) == NULL) {
		    lp->yy_errstr = sdsnew("dup() for NAME failed");
		    lp->yy_error = -ENOMEM;
		    ret = L_ERROR;
		    break;
		}
		ret = L_NAME;
		break;
	    }
	    else if (ltype == L_STRING) {
		if (c != '"')
		    continue;
		/* [-1] and [1] to strip quotes */
		p[-1] = '\0';
		if ((lvalp->s = sdsnew(&lp->yy_tokbuf[1])) == NULL) {
		    lp->yy_errstr = sdsnew("dup() for STRING failed");
		    lp->yy_error = -ENOMEM;
		    ret = L_ERROR;
		    break;
		}
		ret = L_STRING;
		break;
	    }
	    else if (ltype == L_LT) {
		if (c == '=') {
		    *p = '\0';
		    ret = L_LEQ;
		    break;
		}
		else {
		    unget(lp, c);
		    p[-1] = '\0';
		    ret = L_LT;
		    break;
		}
	    }
	    else if (ltype == L_GT) {
		if (c == '=') {
		    *p = '\0';
		    ret = L_GEQ;
		    break;
		}
		else {
		    unget(lp, c);
		    p[-1] = '\0';
		    ret = L_GT;
		    break;
		}
	    }
	    else if (ltype == L_GLOB) {
		if (c == '~') {
		    *p = '\0';
		    ret = L_GLOB;
		    break;
		}
		else {
		    unget(lp, c);
		    p[-1] = '\0';
		    lp->yy_errstr = sdsnew("Illegal character");
		    lp->yy_error = -EINVAL;
		    ret = L_ERROR;
		    break;
		}
	    }
	    else if (ltype == L_EQ) {
		if (c == '=') {
		    *p = '\0';
		    ret = L_EQ;
		    break;
		}
		else if (c == '~') {
		    *p = '\0';
		    ret = L_REQ;
		    break;
		}
		else {
		    unget(lp, c);
		    p[-1] = '\0';
		    ret = L_ASSIGN;
		    break;
		}
	    }
	    else if (ltype == L_NEQ) {
		if (c == '=') {
		    *p = '\0';
		    ret = L_NEQ;
		    break;
		}
		else if (c == '~') {
		    *p = '\0';
		    ret = L_RNE;
		    break;
		}
		else {
		    unget(lp, c);
		    p[-1] = '\0';
		    lp->yy_errstr = sdsnew("Illegal character");
		    lp->yy_error = -EINVAL;
		    ret = L_ERROR;
		    break;
		}
	    }
	    else if (ltype == L_AND) {
		if (c == '&') {
		    *p = '\0';
		    ret = L_AND;
		    break;
		}
		else {
		    unget(lp, c);
		    p[-1] = '\0';
		    lp->yy_errstr = sdsnew("Illegal character");
		    lp->yy_error = -EINVAL;
		    ret = L_ERROR;
		    break;
		}
	    }
	    else if (ltype == L_OR) {
		if (c == '|') {
		    *p = '\0';
		    ret = L_OR;
		    break;
		}
		else {
		    unget(lp, c);
		    p[-1] = '\0';
		    lp->yy_errstr = sdsnew("Illegal character");
		    lp->yy_error = -EINVAL;
		    ret = L_ERROR;
		    break;
		}
	    }
	}
    }

    if (pmDebugOptions.series && pmDebugOptions.appl0)
	fprintf(stderr, "series_lex() -> type=L_%s \"%s\"\n",
		l_type_str(ret), ret == L_EOS ? "" : lp->yy_tokbuf);

    return ret;
}

static int
yylex(YYSTYPE *lvalp, PARSER *lp)
{
    return series_lex(lvalp, lp);
}

static void
series_dumpexpr(node_t *np, int level)
{
    if (np == NULL)
	return;

    series_dumpexpr(np->left, level+1);

    switch (np->type) {
    case N_NAME: case N_INTEGER: case N_DOUBLE:
	fprintf(stderr, "%*s%s", level*4, "", np->value);
	break;
    case N_STRING:
	fprintf(stderr, "%*s\"%s\"", level*4, "", np->value);
	break;
    case N_LT:  case N_LEQ: case N_EQ:  case N_GEQ: case N_GT:  case N_NEQ:
    case N_AND: case N_OR:  case N_RNE: case N_REQ: case N_NEG: case N_GLOB:
    case N_PLUS: case N_MINUS: case N_STAR: case N_SLASH:
	fprintf(stderr, "%*s%s", level*4, "", n_type_c(np->type));
	break;
    case N_AVG: case N_COUNT:   case N_DELTA:   case N_MAX:     case N_MIN:
    case N_SUM: case N_ANON:    case N_RATE:    case N_INSTANT: case N_RESCALE:
	fprintf(stderr, "%*s%s()", level*4, "", n_type_str(np->type));
	break;
    case N_SCALE: {
	char	strbuf[60];

	if (pmUnitsStr_r(&np->meta.units, strbuf, sizeof(strbuf)) == NULL)
	    fprintf(stderr, " [bad units: %d %d %d %d %d %d]",
			np->meta.units.scaleCount, np->meta.units.scaleTime,
			np->meta.units.scaleSpace,
			np->meta.units.dimCount, np->meta.units.dimTime,
			np->meta.units.dimSpace);
	else
	    fprintf(stderr, " [%s]", strbuf);
	break;
	}
    default:
	break;
    }
    fputc('\n', stderr);

    series_dumpexpr(np->right, level+1);
}

int
pmSeriesQuery(pmSeriesSettings *settings, sds query, pmSeriesFlags flags, void *arg)
{
    PARSER	yp = { .yy_base = query, .yy_input = (char *)query };
    series_t	*sp = &yp.yy_series;

    if (yyparse(&yp)) {
	moduleinfo(&settings->module, PMLOG_ERROR, yp.yy_errstr, arg);
	return yp.yy_error;
    }

    if (sp->expr == NULL) {
	if (pmDebugOptions.series || pmDebugOptions.query)
	    fprintf(stderr, "Error: parsing query '%s'\n", query);
	return PM_ERR_NYI;
    }

    if (pmDebugOptions.series)
	series_dumpexpr(sp->expr, 0);

    return series_solve(settings, sp->expr, &sp->time, flags, arg);
}

int
pmSeriesLoad(pmSeriesSettings *settings, sds source, pmSeriesFlags flags, void *arg)
{
    PARSER	yp = { .yy_base = source, .yy_input = (char *)source };
    series_t	*sp = &yp.yy_series;

    if (yyparse(&yp)) {
	moduleinfo(&settings->module, PMLOG_ERROR, yp.yy_errstr, arg);
	return yp.yy_error;
    }

    if (pmDebugOptions.series)
	series_dumpexpr(sp->expr, 0);

    return series_load(settings, sp->expr, &sp->time, flags, arg);
}
